searchData={"content_type":"text/markdown","items":[{"doc":"Utility module to `import` croma macros.\n\n# Usage:\nAdd the following line at the top of source file:\n\n    use Croma","ref":"Croma.html","title":"Croma","type":"module"},{"doc":"Module that represents any Elixir term.","ref":"Croma.Any.html","title":"Croma.Any","type":"module"},{"doc":"","ref":"Croma.Any.html#t:t/0","title":"Croma.Any.t/0","type":"type"},{"doc":"Always returns `true`\nIntended to be used with other parts of croma to express variables with `any` type.","ref":"Croma.Any.html#valid?/1","title":"Croma.Any.valid?/1","type":"function"},{"doc":"Module that represents the Elixir's built-in atom type.\nIntended to be used with other parts of croma to express atom variables.","ref":"Croma.Atom.html","title":"Croma.Atom","type":"module"},{"doc":"","ref":"Croma.Atom.html#t:t/0","title":"Croma.Atom.t/0","type":"type"},{"doc":"Simply checks the argument's type using `is_atom(var!(x))`.","ref":"Croma.Atom.html#valid?/1","title":"Croma.Atom.valid?/1","type":"function"},{"doc":"Module that represents the Elixir's built-in binary type.\nIntended to be used with other parts of croma to express binary variables.","ref":"Croma.Binary.html","title":"Croma.Binary","type":"module"},{"doc":"","ref":"Croma.Binary.html#t:t/0","title":"Croma.Binary.t/0","type":"type"},{"doc":"Simply checks the argument's type using `is_binary(var!(x))`.","ref":"Croma.Binary.html#valid?/1","title":"Croma.Binary.valid?/1","type":"function"},{"doc":"Module that represents the Elixir's built-in bitstring type.\nIntended to be used with other parts of croma to express bitstring variables.","ref":"Croma.BitString.html","title":"Croma.BitString","type":"module"},{"doc":"","ref":"Croma.BitString.html#t:t/0","title":"Croma.BitString.t/0","type":"type"},{"doc":"Simply checks the argument's type using `is_bitstring(var!(x))`.","ref":"Croma.BitString.html#valid?/1","title":"Croma.BitString.valid?/1","type":"function"},{"doc":"Module that represents the Elixir's built-in boolean type.\nIntended to be used with other parts of croma to express boolean variables.","ref":"Croma.Boolean.html","title":"Croma.Boolean","type":"module"},{"doc":"","ref":"Croma.Boolean.html#t:t/0","title":"Croma.Boolean.t/0","type":"type"},{"doc":"Simply checks the argument's type using `is_boolean(var!(x))`.","ref":"Croma.Boolean.html#valid?/1","title":"Croma.Boolean.valid?/1","type":"function"},{"doc":"Module that represents the Elixir's built-in byte type.\nIntended to be used with other parts of croma to express byte variables.","ref":"Croma.Byte.html","title":"Croma.Byte","type":"module"},{"doc":"","ref":"Croma.Byte.html#t:t/0","title":"Croma.Byte.t/0","type":"type"},{"doc":"Simply checks the argument's type using `var!(x) in 0..255`.","ref":"Croma.Byte.html#valid?/1","title":"Croma.Byte.valid?/1","type":"function"},{"doc":"Module that represents the Elixir's built-in char type.\nIntended to be used with other parts of croma to express char variables.","ref":"Croma.Char.html","title":"Croma.Char","type":"module"},{"doc":"","ref":"Croma.Char.html#t:t/0","title":"Croma.Char.t/0","type":"type"},{"doc":"Simply checks the argument's type using `var!(x) in 0..1_114_111`.","ref":"Croma.Char.html#valid?/1","title":"Croma.Char.valid?/1","type":"function"},{"doc":"","ref":"Croma.DebugAssert.html","title":"Croma.DebugAssert","type":"module"},{"doc":"Ensures that the given expression evaluates to some truthy value at runtime and raises otherwise.\n\nThis is intended to be used as debugging purposes: crash immediately when any logic error is found,\nsimilar to `assert()` in C.\nHowever note that, unlike C, crash of the currently running process does not necessarily stop execution of the program.\n\nRuntime checks by `debug_assert/2` can be disabled by setting application config during compilation.\n\n    config :croma, [\n      debug_assert: false\n    ]\n\nThe passed expression should be side effect free in order to preserve code semantics when disabled.","ref":"Croma.DebugAssert.html#debug_assert/2","title":"Croma.DebugAssert.debug_assert/2","type":"macro"},{"doc":"Module that provides `Croma.Defpt.defpt/2` macro.","ref":"Croma.Defpt.html","title":"Croma.Defpt","type":"module"},{"doc":"Defines a unit-testable private function.\nWhen `Mix.env() == :test`, `defpt` defines a public function and thus it can be freely called from tests.\nOtherwise functions defined by `defpt` become private.\nUsage of this macro is exactly the same as the standard `def` and `defp` macros.","ref":"Croma.Defpt.html#defpt/2","title":"Croma.Defpt.defpt/2","type":"macro"},{"doc":"use Croma\n\n    defmodule M do\n      defpt f(x) do\n        IO.inspect(x)\n      end\n    end","ref":"Croma.Defpt.html#defpt/2-example","title":"Example - Croma.Defpt.defpt/2","type":"macro"},{"doc":"Module that provides `Croma.Defun.defun/2` macro.","ref":"Croma.Defun.html","title":"Croma.Defun","type":"module"},{"doc":"Defines a function together with its typespec.\n\nThis provides a lighter-weight syntax for functions with type specifications and functions with multiple clauses.","ref":"Croma.Defun.html#defun/2","title":"Croma.Defun.defun/2","type":"macro"},{"doc":"The following examples assume that `Croma.Defun` is imported\n(you can import it by `use Croma`).\n\n    defun f(a :: integer, b :: String.t) :: String.t do\n      \"#{a} #{b}\"\n    end\n\nThe code above is expanded to the following function definition.\n\n    @spec f(integer, String.t) :: String.t\n    def f(a, b) do\n      \"#{a} #{b}\"\n    end\n\nFunction with multiple clauses and/or pattern matching on parameters can be defined\nin the same way as `case do ... end`:\n\n    defun dumbmap(as :: [a], f :: (a -> b)) :: [b] when a: term, b: term do\n      ([]     , _) -> []\n      ([h | t], f) -> [f.(h) | dumbmap(t, f)]\n    end\n\nis converted to\n\n    @spec dumbmap([a], (a -> b)) :: [b] when a: term, b: term\n    def dumbmap(as, f)\n    def dumbmap([], _) do\n      []\n    end\n    def dumbmap([h | t], f) do\n      [f.(h) | dumbmap(t, f)]\n    end","ref":"Croma.Defun.html#defun/2-example","title":"Example - Croma.Defun.defun/2","type":"macro"},{"doc":"If you omit parameter's type, its type is infered from the parameter's expression.\nSuppose we have the following function:\n\n    defun f(%MyStruct{field1: field1, field2: field2}) :: String.t do\n      \"#{field1} #{field2}\"\n    end\n\nthen the parameter type becomes `MyStruct.t`.\n\n    @spec f(MyStruct.t) :: String.t\n    def f(a1)\n    def f(%MyStruct{field1: field1, field2: field2}) do\n      \"#{field1} #{field2}\"\n    end","ref":"Croma.Defun.html#defun/2-pattern-matching-on-function-parameter-and-omitting-parameter-s-type","title":"Pattern matching on function parameter and omitting parameter's type - Croma.Defun.defun/2","type":"macro"},{"doc":"Simple guard expressions can be generated by `defun/2` using `g[type]` syntax.\nFor example,\n\n    defun f(s :: g[String.t], i :: g[integer]) :: String.t do\n      \"#{s} #{i}\"\n    end\n\nis converted to the following function with `when is_integer(i)` guard.\n\n    @spec f(String.t, integer) :: String.t\n    def f(s, i)\n    def f(s, i) when is_binary(s) and is_integer(i) do\n      \"#{s} #{i}\"\n    end\n\nFor supported types of guard-generation please refer to the source code of `Croma.Guard.make/3`.\n\nGuard generation can be disabled by setting application config at compile time.\nFor example, by putting the following into `config/config.exs`,\n\n    config :croma, [\n      defun_generate_guard: false\n    ]\n\nthen `g[String.t]` becomes semantically the same as `String.t`.","ref":"Croma.Defun.html#defun/2-generating-guards-from-argument-types","title":"Generating guards from argument types - Croma.Defun.defun/2","type":"macro"},{"doc":"You can instrument check of pre/post conditions by specifying type as `v[type]`.\nFor instance,\n\n    defmodule MyString do\n      use Croma.SubtypeOfString, pattern: ~r/^foo|bar$/\n    end\n\n    defun f(s :: v[MyString.t]) :: atom do\n      String.to_atom(s)\n    end\n\nbecomes the following function definition that calls `valid?/1` at the top of its body:\n\n    @spec f(MyString.t) :: atom\n    def f(s)\n    def f(s) do\n      if !MyString.valid?(s) do\n        raise \"...\"\n      end\n      String.to_atom(s)\n    end\n\nThe generated code assumes that `valid?/1` function is defined in the type module of the specified type.\nFor primitive types croma defines their type modules and thus you can freely use e.g. `v[integer]`.\n\nGenerating validation of arguments and return values can be disabled by setting application config during compilation.\n\n    config :croma, [\n      defun_generate_validation: false\n    ]","ref":"Croma.Defun.html#defun/2-validating-arguments-and-return-value-based-on-their-types","title":"Validating arguments and return value based on their types - Croma.Defun.defun/2","type":"macro"},{"doc":"- Overloaded typespecs are not supported.\n- Guard generation and validation are not allowed to be used with multi-clause syntax.\n- Using unquote fragment in parameter list is not fully supported.\n- `try` block is not implicitly started in body of `defun`, in contrast to `def`.","ref":"Croma.Defun.html#defun/2-known-limitations","title":"Known limitations - Croma.Defun.defun/2","type":"macro"},{"doc":"Defines a private function together with its typespec.\n\nSee `defun/2` for usage of this macro.","ref":"Croma.Defun.html#defunp/2","title":"Croma.Defun.defunp/2","type":"macro"},{"doc":"Defines a unit-testable private function together with its typespec.\n\nSee `defun/2` for usage of this macro.\nSee also `Croma.Defpt.defpt/2`.","ref":"Croma.Defun.html#defunpt/2","title":"Croma.Defun.defunpt/2","type":"macro"},{"doc":"Module that represents the Elixir's built-in float type.\nIntended to be used with other parts of croma to express float variables.","ref":"Croma.Float.html","title":"Croma.Float","type":"module"},{"doc":"","ref":"Croma.Float.html#t:t/0","title":"Croma.Float.t/0","type":"type"},{"doc":"Simply checks the argument's type using `is_float(var!(x))`.","ref":"Croma.Float.html#valid?/1","title":"Croma.Float.valid?/1","type":"function"},{"doc":"Module that represents the Elixir's built-in function type.\nIntended to be used with other parts of croma to express function variables.","ref":"Croma.Function.html","title":"Croma.Function","type":"module"},{"doc":"","ref":"Croma.Function.html#t:t/0","title":"Croma.Function.t/0","type":"type"},{"doc":"Simply checks the argument's type using `is_function(var!(x))`.","ref":"Croma.Function.html#valid?/1","title":"Croma.Function.valid?/1","type":"function"},{"doc":"Module to work with guard generation (see `Croma.Defun.defun/2`).\nThis module is intended for internal use.","ref":"Croma.Guard.html","title":"Croma.Guard","type":"module"},{"doc":"","ref":"Croma.Guard.html#make/3","title":"Croma.Guard.make/3","type":"function"},{"doc":"Module that represents the Elixir's built-in integer type.\nIntended to be used with other parts of croma to express integer variables.","ref":"Croma.Integer.html","title":"Croma.Integer","type":"module"},{"doc":"","ref":"Croma.Integer.html#t:t/0","title":"Croma.Integer.t/0","type":"type"},{"doc":"Simply checks the argument's type using `is_integer(var!(x))`.","ref":"Croma.Integer.html#valid?/1","title":"Croma.Integer.valid?/1","type":"function"},{"doc":"Module that represents the Elixir's built-in list type.\nIntended to be used with other parts of croma to express list variables.","ref":"Croma.List.html","title":"Croma.List","type":"module"},{"doc":"","ref":"Croma.List.html#t:t/0","title":"Croma.List.t/0","type":"type"},{"doc":"Simply checks the argument's type using `is_list(var!(x))`.","ref":"Croma.List.html#valid?/1","title":"Croma.List.valid?/1","type":"function"},{"doc":"Implementation of `Croma.Monad` interface for built-in lists.\n\nThis empowers the following Haskell-ish syntax for loops using lists:\n\n    iex> use Croma\n    ...> Croma.ListMonad.m do\n    ...>   i <- [1, 2, 3]\n    ...>   j <- [10, 20]\n    ...>   pure i + j\n    ...> end\n    [11, 21, 12, 22, 13, 23]","ref":"Croma.ListMonad.html","title":"Croma.ListMonad","type":"module"},{"doc":"Default implementation of Applicative's `ap` operation.\nModules that implement `Croma.Monad` may override this default implementation.\nNote that the order of arguments is different from the Haskell counterpart, in order to leverage Elixir's pipe operator `|>`.","ref":"Croma.ListMonad.html#ap/2","title":"Croma.ListMonad.ap/2","type":"function"},{"doc":"Implementation of `bind` operation of Monad.\nAlias to `Enum.flat_map/2`.","ref":"Croma.ListMonad.html#bind/2","title":"Croma.ListMonad.bind/2","type":"function"},{"doc":"A macro that provides Hakell-like do-notation.","ref":"Croma.ListMonad.html#m/1","title":"Croma.ListMonad.m/1","type":"macro"},{"doc":"MonadImpl.m do\n      x <- mx\n      y <- my\n      pure f(x, y)\n    end\n\nis expanded to\n\n    MonadImpl.bind(mx, fn x ->\n      MonadImpl.bind(my, fn y ->\n        MonadImpl.pure f(x, y)\n      end)\n    end)","ref":"Croma.ListMonad.html#m/1-examples","title":"Examples - Croma.ListMonad.m/1","type":"macro"},{"doc":"Default implementation of Functor's `fmap` operation.\nModules that implement `Croma.Monad` may override this default implementation.\nNote that the order of arguments is different from the Haskell counterpart, in order to leverage Elixir's pipe operator `|>`.","ref":"Croma.ListMonad.html#map/2","title":"Croma.ListMonad.map/2","type":"function"},{"doc":"Implementation of `pure` operation of Monad (or Applicative).\nWraps the given value into a list.","ref":"Croma.ListMonad.html#pure/1","title":"Croma.ListMonad.pure/1","type":"function"},{"doc":"Converts the given list of monadic (to be precise, applicative) objects into a monadic object that contains a single list.\nModules that implement `Croma.Monad` may override this default implementation.","ref":"Croma.ListMonad.html#sequence/1","title":"Croma.ListMonad.sequence/1","type":"function"},{"doc":"iex> Croma.Result.sequence([{:ok, 1}, {:ok, 2}, {:ok, 3}])\n    {:ok, [1, 2, 3]}\n\n    iex> Croma.Result.sequence([{:ok, 1}, {:error, :foo}, {:ok, 3}])\n    {:error, :foo}","ref":"Croma.ListMonad.html#sequence/1-examples-using-croma-result","title":"Examples (using Croma.Result) - Croma.ListMonad.sequence/1","type":"function"},{"doc":"","ref":"Croma.ListMonad.html#t:t/1","title":"Croma.ListMonad.t/1","type":"type"},{"doc":"Module that represents the Elixir's built-in map type.\nIntended to be used with other parts of croma to express map variables.","ref":"Croma.Map.html","title":"Croma.Map","type":"module"},{"doc":"","ref":"Croma.Map.html#t:t/0","title":"Croma.Map.t/0","type":"type"},{"doc":"Simply checks the argument's type using `is_map(var!(x))`.","ref":"Croma.Map.html#valid?/1","title":"Croma.Map.valid?/1","type":"function"},{"doc":"This module defines an interface for [monad](https://en.wikipedia.org/wiki/Monad).\n\nModules that `use` this module must provide concrete implementations of the following:\n\n- `@type t(a)`\n- `@spec pure(a) :: t(a) when a: any`\n- `@spec bind(t(a), (a -> t(b))) :: t(b) when a: any, b: any`\n\nNote that the order of parameters in `map`/`ap` is different from that of Haskell counterparts,\nin order to leverage Elixir's pipe operator `|>`.\nUsing concrete implementations of the above interfaces, this module generates default implementations of some functions/macros.\nSee `Croma.Result` for the generated functions/macros.\n\n`Croma.Monad` also provides `bind`-less syntax similar to Haskell's do-notation with `m/1` macro.","ref":"Croma.Monad.html","title":"Croma.Monad","type":"module"},{"doc":"Module that represents the Elixir's built-in neg_integer type.\nIntended to be used with other parts of croma to express neg_integer variables.","ref":"Croma.NegInteger.html","title":"Croma.NegInteger","type":"module"},{"doc":"","ref":"Croma.NegInteger.html#t:t/0","title":"Croma.NegInteger.t/0","type":"type"},{"doc":"Simply checks the argument's type using `is_integer(var!(x)) and var!(x) < 0`.","ref":"Croma.NegInteger.html#valid?/1","title":"Croma.NegInteger.valid?/1","type":"function"},{"doc":"Module that represents the Elixir's built-in non_neg_integer type.\nIntended to be used with other parts of croma to express non_neg_integer variables.","ref":"Croma.NonNegInteger.html","title":"Croma.NonNegInteger","type":"module"},{"doc":"","ref":"Croma.NonNegInteger.html#t:t/0","title":"Croma.NonNegInteger.t/0","type":"type"},{"doc":"Simply checks the argument's type using `is_integer(var!(x)) and var!(x) >= 0`.","ref":"Croma.NonNegInteger.html#valid?/1","title":"Croma.NonNegInteger.valid?/1","type":"function"},{"doc":"Module that represents the Elixir's built-in number type.\nIntended to be used with other parts of croma to express number variables.","ref":"Croma.Number.html","title":"Croma.Number","type":"module"},{"doc":"","ref":"Croma.Number.html#t:t/0","title":"Croma.Number.t/0","type":"type"},{"doc":"Simply checks the argument's type using `is_number(var!(x))`.","ref":"Croma.Number.html#valid?/1","title":"Croma.Number.valid?/1","type":"function"},{"doc":"Module that represents the Elixir's built-in pid type.\nIntended to be used with other parts of croma to express pid variables.","ref":"Croma.Pid.html","title":"Croma.Pid","type":"module"},{"doc":"","ref":"Croma.Pid.html#t:t/0","title":"Croma.Pid.t/0","type":"type"},{"doc":"Simply checks the argument's type using `is_pid(var!(x))`.","ref":"Croma.Pid.html#valid?/1","title":"Croma.Pid.valid?/1","type":"function"},{"doc":"Module that represents the Elixir's built-in port type.\nIntended to be used with other parts of croma to express port variables.","ref":"Croma.Port.html","title":"Croma.Port","type":"module"},{"doc":"","ref":"Croma.Port.html#t:t/0","title":"Croma.Port.t/0","type":"type"},{"doc":"Simply checks the argument's type using `is_port(var!(x))`.","ref":"Croma.Port.html#valid?/1","title":"Croma.Port.valid?/1","type":"function"},{"doc":"Module that represents the Elixir's built-in pos_integer type.\nIntended to be used with other parts of croma to express pos_integer variables.","ref":"Croma.PosInteger.html","title":"Croma.PosInteger","type":"module"},{"doc":"","ref":"Croma.PosInteger.html#t:t/0","title":"Croma.PosInteger.t/0","type":"type"},{"doc":"Simply checks the argument's type using `is_integer(var!(x)) and var!(x) > 0`.","ref":"Croma.PosInteger.html#valid?/1","title":"Croma.PosInteger.valid?/1","type":"function"},{"doc":"Module that represents the Elixir's built-in reference type.\nIntended to be used with other parts of croma to express reference variables.","ref":"Croma.Reference.html","title":"Croma.Reference","type":"module"},{"doc":"","ref":"Croma.Reference.html#t:t/0","title":"Croma.Reference.t/0","type":"type"},{"doc":"Simply checks the argument's type using `is_reference(var!(x))`.","ref":"Croma.Reference.html#valid?/1","title":"Croma.Reference.valid?/1","type":"function"},{"doc":"A simple data structure to represent a result of computation that can either succeed or fail,\nin the form of `{:ok, any}` or `{:error, any}`.\n\nIn addition to many utility functions, this module also provides implementation of\n`Croma.Monad` interface for `t:Croma.Result.t/1`.\nThis enables the following Haskell-ish syntax:\n\n    iex> use Croma\n    ...> Croma.Result.m do\n    ...>   x <- {:ok, 1}\n    ...>   y <- {:ok, 2}\n    ...>   pure x + y\n    ...> end\n    {:ok, 3}\n\nThe above code is expanded to the code that uses `pure/1` and `bind/2`.\n\n    Croma.Result.bind({:ok, 1}, fn x ->\n      Croma.Result.bind({:ok, 2}, fn y ->\n        Croma.Result.pure(x + y)\n      end)\n    end)\n\nThis is useful when handling multiple computations that may go wrong in a short-circuit manner:\n\n    iex> use Croma\n    ...> Croma.Result.m do\n    ...>   x <- {:error, :foo}\n    ...>   y <- {:ok, 2}\n    ...>   pure x + y\n    ...> end\n    {:error, :foo}","ref":"Croma.Result.html","title":"Croma.Result","type":"module"},{"doc":"Default implementation of Applicative's `ap` operation.\nModules that implement `Croma.Monad` may override this default implementation.\nNote that the order of arguments is different from the Haskell counterpart, in order to leverage Elixir's pipe operator `|>`.","ref":"Croma.Result.html#ap/2","title":"Croma.Result.ap/2","type":"function"},{"doc":"Implementation of `bind` operation of Monad.\nExecutes the given function if the result is in `:ok` state; otherwise returns the failed result.","ref":"Croma.Result.html#bind/2","title":"Croma.Result.bind/2","type":"function"},{"doc":"Based on existing functions that return `Croma.Result.t(any)`, defines functions that raise on error.\n\nEach generated function simply calls the specified function and then passes the returned value to `Croma.Result.get!/1`.","ref":"Croma.Result.html#define_bang_version_of/1","title":"Croma.Result.define_bang_version_of/1","type":"macro"},{"doc":"iex> defmodule M do\n    ...>   def f(a) do\n    ...>     {:ok, a + 1}\n    ...>   end\n    ...>   Croma.Result.define_bang_version_of(f: 1)\n    ...> end\n    iex> M.f(1)\n    {:ok, 2}\n    iex> M.f!(1)\n    2\n\nIf appropriate spec of original function is available, spec of the bang version is also declared.\nFor functions that have default arguments it's necessary to explicitly pass all arities to `Croma.Result.define_bang_version_of/1`.","ref":"Croma.Result.html#define_bang_version_of/1-examples","title":"Examples - Croma.Result.define_bang_version_of/1","type":"macro"},{"doc":"Returns true if the given result is in the form of `{:error, _}`.","ref":"Croma.Result.html#error?/1","title":"Croma.Result.error?/1","type":"function"},{"doc":"Returns the value associated with `:ok` in the given result.\nReturns `nil` if the result is in the form of `{:error, _}`.","ref":"Croma.Result.html#get/1","title":"Croma.Result.get/1","type":"function"},{"doc":"iex> Croma.Result.get({:ok, 1})\n    1\n\n    iex> Croma.Result.get({:error, :foo})\n    nil","ref":"Croma.Result.html#get/1-examples","title":"Examples - Croma.Result.get/1","type":"function"},{"doc":"Returns the value associated with `:ok` in the given result.\nReturns `default` if the result is in the form of `{:error, _}`.","ref":"Croma.Result.html#get/2","title":"Croma.Result.get/2","type":"function"},{"doc":"iex> Croma.Result.get({:ok, 1}, 0)\n    1\n\n    iex> Croma.Result.get({:error, :foo}, 0)\n    0","ref":"Croma.Result.html#get/2-examples","title":"Examples - Croma.Result.get/2","type":"function"},{"doc":"Returns the value associated with `:ok` in the given result.\nRaises `ArgumentError` if the result is in the form of `{:error, _}`.","ref":"Croma.Result.html#get!/1","title":"Croma.Result.get!/1","type":"function"},{"doc":"iex> Croma.Result.get!({:ok, 1})\n    1\n\n    iex> Croma.Result.get!({:error, :foo})\n    ** (ArgumentError) element not present: {:error, :foo}","ref":"Croma.Result.html#get!/1-examples","title":"Examples - Croma.Result.get!/1","type":"function"},{"doc":"A macro that provides Hakell-like do-notation.","ref":"Croma.Result.html#m/1","title":"Croma.Result.m/1","type":"macro"},{"doc":"MonadImpl.m do\n      x <- mx\n      y <- my\n      pure f(x, y)\n    end\n\nis expanded to\n\n    MonadImpl.bind(mx, fn x ->\n      MonadImpl.bind(my, fn y ->\n        MonadImpl.pure f(x, y)\n      end)\n    end)","ref":"Croma.Result.html#m/1-examples","title":"Examples - Croma.Result.m/1","type":"macro"},{"doc":"Default implementation of Functor's `fmap` operation.\nModules that implement `Croma.Monad` may override this default implementation.\nNote that the order of arguments is different from the Haskell counterpart, in order to leverage Elixir's pipe operator `|>`.","ref":"Croma.Result.html#map/2","title":"Croma.Result.map/2","type":"function"},{"doc":"Transforms a result by applying a function to its contained `:error` value.\nIf the given result is in `:ok` state it is returned without using the given function.","ref":"Croma.Result.html#map_error/2","title":"Croma.Result.map_error/2","type":"function"},{"doc":"Returns true if the given result is in the form of `{:ok, _value}`.","ref":"Croma.Result.html#ok?/1","title":"Croma.Result.ok?/1","type":"function"},{"doc":"Tries to take one result in `:ok` state from the given two.\nIf the first result is in `:ok` state it is returned.\nOtherwise the second result is returned.\nNote that `or_else/2` is a macro instead of a function in order to short-circuit evaluation of the second argument,\ni.e. the second argument is evaluated only when the first argument is in `:error` state.","ref":"Croma.Result.html#or_else/2","title":"Croma.Result.or_else/2","type":"macro"},{"doc":"Implementation of `pure` operation of Monad (or Applicative).\nWraps the given value into a `Croma.Result`, i.e., returns `{:ok, arg}`.","ref":"Croma.Result.html#pure/1","title":"Croma.Result.pure/1","type":"function"},{"doc":"Converts the given list of monadic (to be precise, applicative) objects into a monadic object that contains a single list.\nModules that implement `Croma.Monad` may override this default implementation.","ref":"Croma.Result.html#sequence/1","title":"Croma.Result.sequence/1","type":"function"},{"doc":"iex> Croma.Result.sequence([{:ok, 1}, {:ok, 2}, {:ok, 3}])\n    {:ok, [1, 2, 3]}\n\n    iex> Croma.Result.sequence([{:ok, 1}, {:error, :foo}, {:ok, 3}])\n    {:error, :foo}","ref":"Croma.Result.html#sequence/1-examples-using-croma-result","title":"Examples (using Croma.Result) - Croma.Result.sequence/1","type":"function"},{"doc":"","ref":"Croma.Result.html#t:t/0","title":"Croma.Result.t/0","type":"type"},{"doc":"","ref":"Croma.Result.html#t:t/1","title":"Croma.Result.t/1","type":"type"},{"doc":"","ref":"Croma.Result.html#t:t/2","title":"Croma.Result.t/2","type":"type"},{"doc":"Executes the given function within a try-rescue block and wraps the return value as `{:ok, retval}`.\nIf the function raises an exception, `try/1` returns the exception in the form of `{:error, exception}`.","ref":"Croma.Result.html#try/1","title":"Croma.Result.try/1","type":"function"},{"doc":"iex> Croma.Result.try(fn -> 1 + 1 end)\n    {:ok, 2}\n\n    iex> Croma.Result.try(fn -> raise \"foo\" end)\n    {:error, %RuntimeError{message: \"foo\"}}","ref":"Croma.Result.html#try/1-examples","title":"Examples - Croma.Result.try/1","type":"function"},{"doc":"Simply checks if the given term is ok- or error-tuple.\n\nUsing this function you can write e.g.\n`r :: v[Croma.Result.t(integer)]`\nin your parameter list of `defun` macro to validate `r` is of type `t:t/0`.\nHowever note that this function only checks the outmost structure of an argument;\n2nd value in the 2-tuple won't be validated for the given type parameter\n(in the above example it won't verify whether `r` contains an `integer` or not).","ref":"Croma.Result.html#valid?/1","title":"Croma.Result.valid?/1","type":"function"},{"doc":"Wraps a given value in an `:ok` tuple if `mod.valid?/1` returns true for the value.\nOtherwise returns an `:error` tuple.","ref":"Croma.Result.html#wrap_if_valid/2","title":"Croma.Result.wrap_if_valid/2","type":"function"},{"doc":"Module that represents the Elixir's built-in String.t type.\nIntended to be used with other parts of croma to express String.t variables.","ref":"Croma.String.html","title":"Croma.String","type":"module"},{"doc":"","ref":"Croma.String.html#t:t/0","title":"Croma.String.t/0","type":"type"},{"doc":"Simply checks the argument's type using `is_binary(var!(x))`.","ref":"Croma.String.html#valid?/1","title":"Croma.String.valid?/1","type":"function"},{"doc":"Module to define structs with validation and conversion functions, based on its type information.\n\nUsing this module requires to prepare type modules for all struct fields.\nEach of per-field type module is expected to provide the following members:\n\n- required: `@type t`\n- required: `@spec valid?(term) :: boolean`\n- optional: `@spec default() :: t`\n- optional: `@spec new(term) :: Croma.Result.t(t)`\n\nSome helpers for defining such per-field type modules are available.\n\n- Wrappers of built-in types such as `Croma.String`, `Croma.Integer`, etc.\n- Utility modules such as `Croma.SubtypeOfString` to define \"subtypes\" of existing types.\n- Ad-hoc module generators defined in `Croma.TypeGen`.\n- This module, `Croma.Struct` itself for nested structs.\n\nTo define a struct, `use` this module with a keyword list where keys are field names and values are type modules:\n\n    defmodule S do\n      use Croma.Struct, fields: [\n        field1_name: Field1Module,\n        field2_name: Field2Module,\n      ]\n    end\n\nThen the above code generates `defstruct`, `@type t` and the following functions:\n\n- `@spec valid?(term) :: boolean`\n- `@spec new(term) :: Croma.Result.t(t)`\n- `@spec new!(term) :: t`\n- `@spec update(t, Dict.t) :: Croma.Result.t(t)`\n- `@spec update!(t, Dict.t) :: t`\n\nThe functions listed above are all overridable, so you can\nfor example implement your own validation rule that spans multiple fields.","ref":"Croma.Struct.html","title":"Croma.Struct","type":"module"},{"doc":"iex> defmodule I do\n    ...>   @type t :: integer\n    ...>   def valid?(i), do: is_integer(i)\n    ...>   def default(), do: 0\n    ...> end\n\n    ...> defmodule S do\n    ...>   use Croma.Struct, fields: [i: I]\n    ...> end\n\n    ...> S.new(%{i: 5})\n    {:ok, %S{i: 5}}\n\n    ...> S.valid?(%S{i: \"not_an_integer\"})\n    false\n\n    ...> {:ok, s} = S.new(%{})\n    {:ok, %S{i: 0}}\n\n    ...> S.update(s, [i: 2])\n    {:ok, %S{i: 2}}\n\n    ...> S.update(s, %{\"i\" => \"not_an_integer\"})\n    {:error, {:invalid_value, [S, {I, :i}]}}","ref":"Croma.Struct.html#module-examples","title":"Examples - Croma.Struct","type":"module"},{"doc":"You can specify default value of each struct field by\n\n1. giving `:default` option in per-field options\n2. defining `default/0` in the field's type module (which is evaluated at compile-time)\n\nIf you specify both, (1) takes precedence over (2).\nAdditionally, you can tell `Croma.Struct` not to use `default/0` by specifying `no_default?: true`.\nIf no default value is provided for a field, then the field must be explicitly filled when constructing a new struct.\n\nAs an example, suppose you have the following modules.\n    defmodule I do\n      use Croma.SubtypeOfInt, min: 0, default: 1\n    end\n\n    defmodule S do\n      use Croma.Struct, fields: [\n        a: Croma.Integer,\n        b: I,\n        c: {Croma.Integer, [default: 2]},\n        d: {I            , [default: 3]},\n        e: {Croma.Integer, [no_default?: true]},\n        f: {I            , [no_default?: true]},\n      ]\n    end\n\nNote that `I` has `default/0` whereas `Croma.Integer` does not export `default/0`.\nThen,\n- `a`, `e` and `f` have no default values\n- Default value of `b` is `1`\n- Default value of `c` is `2`\n- Default value of `d` is `3`\n\n## `new/1`\n\n`new/1` generated by `Croma.Struct` deserves special attention.\n`new/1` can be useful when validating and converting data structure obtained from\ne.g. JSON into an Elixir structs.\n\nAs with other type modules' `new/1`, `new/1` generated by `Croma.Struct` can accept\nvalue where `valid?/1` evaluates to `false`; it tries to convert that value into a\nvalid form.\nMost notable example of this behaviour is that `new/1` accepts not only atom-keyed\nmaps but also string-keyed maps, although structs are atom-keyed maps.","ref":"Croma.Struct.html#module-default-value-of-each-field","title":"Default value of each field - Croma.Struct","type":"module"},{"doc":"`new/1` tries to get valid values for all struct fields from the given map or keyword list.\nFor each field of the struct, a value is computed as follows:\n\n- If a value is not found for a field,\n    - If the field has default value, that default is taken.\n- If a value is found for a field,\n    - If the module for the field exports `new/1` it is called with the found value.\n    - If the module for the field does not export `new/1`, the found value is instead\n      validated with `valid?/1`.\n\nWhen no valid value can be obtained for any of the struct fields, `new/1` returns an error.\nNote that the usage of field modules' `new/1` enables to construct arbitrarily nested\ndata structure in a recursive manner.","ref":"Croma.Struct.html#module-how-it-works","title":"How it works - Croma.Struct","type":"module"},{"doc":"When working with structured data (e.g. JSON) from systems with different naming conventions,\nit's convenient to adjust the names to your favorite convention in this layer.\nYou can specify the acceptable naming schemes of data structures to be converted\nby `new/1` and `new!/1` using `:accept_case` option of `use Croma.Struct`.\n\n- `nil` (default): Accepts only the given field names.\n- `:lower_camel`: Accepts both the given field names and their lower camel variants.\n- `:upper_camel`: Accepts both the given field names and their upper camel variants.\n- `:snake`: Accepts both the given field names and their snake cased variants.\n- `:capital`: Accepts both the given field names and their variants where all characters are capital.","ref":"Croma.Struct.html#module-naming-convention-of-field-names-case-of-identifiers","title":"Naming convention of field names (case of identifiers) - Croma.Struct","type":"module"},{"doc":"","ref":"Croma.Struct.html#module-tips","title":"Tips - Croma.Struct","type":"module"},{"doc":"Simply using `Croma.TypeGen.nilable/1` for struct fields, we cannot distinguish\nwhether the value is not given or `nil` is explicitly given, as the resulting\nstruct contains `nil` for both cases.\n\nBy adjusting default value for the field we can distinguish these case.\nAs an example suppose we have the following `S`.\n\n    defmodule S do\n      use Croma.Struct, fields: [\n        field: {union([fixed(:unset), fixed(nil), Croma.Integer]), [default: :unset]},\n      ]\n    end\n\nThen we can distinguish these patterns.\n\n- `S.new(%{}) == %S{field: :unset}`\n- `S.new(%{field: nil}) == %S{field: nil}`\n- `S.new(%{field: 1}) == %S{field: 1}`\n\nIn this example we use `Croma.TypeGen.union/1` and `Croma.TypeGen.fixed/1`, but one can of course\ndefine his/her own type module that accepts these 3 cases.\nIn a similar manner, by setting default value for field we can implement struct fields that\n\n- accepts missing field but rejects explicit `nil`, or\n- accepts explicit `nil` but rejects missing field.","ref":"Croma.Struct.html#module-to-distinguish-missing-field-and-explict-nil-in-new-1","title":"To distinguish missing field and explict `nil` in `new/1` - Croma.Struct","type":"module"},{"doc":"Helper module to define type whose members are a fixed set of atoms.\nThe following members are generated by `use Croma.SubtypeOfAtom`:\n\n- `@type t`\n- `@spec valid?(term) :: boolean`\n- `@spec new(term) :: Croma.Result.t(t)` (tries to convert `String.t` to the given set of atoms)\n- `@spec new!(term) :: t`\n\nOptions:\n- `:values` - List of atoms of possible values.\n- `:default` - Default value for this type. Passing this option generates `default/0`.","ref":"Croma.SubtypeOfAtom.html","title":"Croma.SubtypeOfAtom","type":"module"},{"doc":"defmodule MyAtom do\n      use Croma.SubtypeOfAtom, values: [:foo, :bar, :baz], default: :foo\n    end","ref":"Croma.SubtypeOfAtom.html#module-examples","title":"Examples - Croma.SubtypeOfAtom","type":"module"},{"doc":"Helper module to define float-based types.\nThe following members are generated by `use Croma.SubtypeOfFloat`:\n\n- `@type t`\n- `@spec valid?(term) :: boolean`\n\nOptions:\n- `:min` - Minimum value of this type (inclusive).\n- `:max` - Maximum value of this type (inclusive).\n- `:default` - Default value for this type. Passing this option generates `default/0`.","ref":"Croma.SubtypeOfFloat.html","title":"Croma.SubtypeOfFloat","type":"module"},{"doc":"defmodule MyFloat do\n      use Croma.SubtypeOfFloat, min: 0.0, max: 5.0, default: 0.0\n    end","ref":"Croma.SubtypeOfFloat.html#module-examples","title":"Examples - Croma.SubtypeOfFloat","type":"module"},{"doc":"Helper module to define float-based types.\nThe following members are generated by `use Croma.SubtypeOfFloatWithConversionFromInt`:\n\n- `@type t`\n- `@spec valid?(term) :: boolean`\n- `@spec new(term) :: Croma.Result.t(t)`\n\nThis variant of `Croma.SubtypeOfFloat` is useful for e.g. float field in a struct that\nmodels JSON data so that both `1.0` and `1` in JSON representation can be automatically\nconverted to elixir's float value by `new/1`.\n\nOptions:\n- `:min` - Minimum value of this type (inclusive).\n- `:max` - Maximum value of this type (inclusive).\n- `:default` - Default value for this type. Passing this option generates `default/0`.","ref":"Croma.SubtypeOfFloatWithConversionFromInt.html","title":"Croma.SubtypeOfFloatWithConversionFromInt","type":"module"},{"doc":"defmodule MyFloat do\n      use Croma.SubtypeOfFloatWithConversionFromInt, min: 0.0, max: 5.0, default: 0.0\n    end","ref":"Croma.SubtypeOfFloatWithConversionFromInt.html#module-examples","title":"Examples - Croma.SubtypeOfFloatWithConversionFromInt","type":"module"},{"doc":"Helper module to define integer-based types.\nThe following members are generated by `use Croma.SubtypeOfInt`:\n\n- `@type t`\n- `@spec valid?(term) :: boolean`\n\nOptions:\n- `:min` - Minimum value of this type (inclusive).\n- `:max` - Maximum value of this type (inclusive).\n- `:default` - Default value for this type. Passing this option generates `default/0`.","ref":"Croma.SubtypeOfInt.html","title":"Croma.SubtypeOfInt","type":"module"},{"doc":"defmodule MyInt do\n      use Croma.SubtypeOfInt, min: 0, max: 10, default: 0\n    end","ref":"Croma.SubtypeOfInt.html#module-examples","title":"Examples - Croma.SubtypeOfInt","type":"module"},{"doc":"Helper module to define list-based types.\nThe following members are generated by `use Croma.SubtypeOfList`:\n\n- `@type t`\n- `@spec valid?(term) :: boolean`\n- If `elem_module` exports `new/1`,\n    - `@spec new(term) :: Croma.Result.t(t)`\n    - `@spec new!(term) :: t`\n\nOptions:\n- `:elem_module` - A type module for elements.\n- `:min_length` - Minimum length of valid values of this type (inclusive).\n- `:max_length` - Maximum length of valid values of this type (inclusive).\n- `:default` - Default value for this type. Passing this option generates `default/0`.","ref":"Croma.SubtypeOfList.html","title":"Croma.SubtypeOfList","type":"module"},{"doc":"defmodule MyList do\n      use Croma.SubtypeOfList, elem_module: MyInt, default: []\n    end","ref":"Croma.SubtypeOfList.html#module-examples","title":"Examples - Croma.SubtypeOfList","type":"module"},{"doc":"Helper module to define map-based types.\nThe following members are generated by `use Croma.SubtypeOfMap`:\n\n- `@type t`\n- `@spec valid?(term) :: boolean`\n- If `key_module` and/or `value_module` exports `new/1`,\n    - `@spec new(term) :: Croma.Result.t(t)`\n    - `@spec new!(term) :: t`\n\nOptions:\n- `:key_module` - A type module for keys.\n- `:value_module` - A type module for values.\n- `:min_size` - Minimum size of valid values of this type (inclusive).\n- `:max_size` - Maximum size of valid values of this type (inclusive).\n- `:default` - Default value for this type. Passing this option generates `default/0`.","ref":"Croma.SubtypeOfMap.html","title":"Croma.SubtypeOfMap","type":"module"},{"doc":"defmodule MyMap do\n      use Croma.SubtypeOfMap, key_module: MyString, value_module: MyInt, default: %{}\n    end","ref":"Croma.SubtypeOfMap.html#module-examples","title":"Examples - Croma.SubtypeOfMap","type":"module"},{"doc":"Helper module to define number-based (integer or float) types.\nThe following members are generated by `use Croma.SubtypeOfNumber`:\n\n- `@type t`\n- `@spec valid?(term) :: boolean`\n\nOptions:\n- `:min` - Minimum value of this type (inclusive).\n- `:max` - Maximum value of this type (inclusive).\n- `:default` - Default value for this type. Passing this option generates `default/0`.","ref":"Croma.SubtypeOfNumber.html","title":"Croma.SubtypeOfNumber","type":"module"},{"doc":"defmodule MyNumber do\n      use Croma.SubtypeOfNumber, min: 0, max: 3.141592653589793, default: 0\n    end","ref":"Croma.SubtypeOfNumber.html#module-examples","title":"Examples - Croma.SubtypeOfNumber","type":"module"},{"doc":"Helper module to define string-based types.\nThe following members are generated by `use Croma.SubtypeOfString`:\n\n- `@type t`\n- `@spec valid?(term) :: boolean`\n\nOptions:\n- `:pattern` - A regex pattern to check whether a string is classified into this type or not.\n- `:default` - Default value for this type. Passing this option generates `default/0`.","ref":"Croma.SubtypeOfString.html","title":"Croma.SubtypeOfString","type":"module"},{"doc":"defmodule MyString do\n      use Croma.SubtypeOfString, pattern: ~r/^foo|bar$/, default: \"foo\"\n    end","ref":"Croma.SubtypeOfString.html#module-examples","title":"Examples - Croma.SubtypeOfString","type":"module"},{"doc":"Helper module to define tuple-based types.\nThe following members are generated by `use Croma.SubtypeOfTuple`:\n\n- `@type t`\n- `@spec valid?(term) :: boolean`\n- If any of `:elem_modules` exports `new/1`,\n    - `@spec new(term) :: Croma.Result.t(t)`\n    - `@spec new!(term) :: t`\n\nOptions:\n- `:elem_modules` - A list of type modules for tuple elements.\n- `:default` - Default value for this type. Passing this option generates `default/0`.","ref":"Croma.SubtypeOfTuple.html","title":"Croma.SubtypeOfTuple","type":"module"},{"doc":"defmodule MyTuple do\n      use Croma.SubtypeOfTuple, elem_modules: [MyInt, MyString]\n    end","ref":"Croma.SubtypeOfTuple.html#module-examples","title":"Examples - Croma.SubtypeOfTuple","type":"module"},{"doc":"Module to be `use`d by test modules to make tests a bit shorter.\n\n`use Croma.TestCase` is almost the same as `use ExUnit.Case`.\nOptions passed to `use Croma.TestCase` will also be passed to `use ExUnit.Case`.\n\nThe only difference is that it automatically adds an alias to the test target module,\nwhich is inferred from the name of the test module.","ref":"Croma.TestCase.html","title":"Croma.TestCase","type":"module"},{"doc":"defmodule MyProject.SomeModuleTest do\n      use Croma.TestCase\n      ...\n    end\n\nis equivalent to\n\n    defmodule MyProject.SomeModuleTest do\n      use ExUnit.Case\n      alias MyProject.SomeModule\n      ...\n    end\n\nIf you want to pass `as` option to `alias`, use `alias_as`:\n\n    defmodule MyProject.SomeModuleTest do\n      use Croma.TestCase, alias_as: M\n      ...\n    end\n\nis converted to\n\n    defmodule MyProject.SomeModuleTest do\n      use ExUnit.Case\n      alias MyProject.SomeModule, as: M\n      ...\n    end","ref":"Croma.TestCase.html#module-example","title":"Example - Croma.TestCase","type":"module"},{"doc":"Module that represents the Elixir's built-in tuple type.\nIntended to be used with other parts of croma to express tuple variables.","ref":"Croma.Tuple.html","title":"Croma.Tuple","type":"module"},{"doc":"","ref":"Croma.Tuple.html#t:t/0","title":"Croma.Tuple.t/0","type":"type"},{"doc":"Simply checks the argument's type using `is_tuple(var!(x))`.","ref":"Croma.Tuple.html#valid?/1","title":"Croma.Tuple.valid?/1","type":"function"},{"doc":"Module that defines macros for ad-hoc (in other words \"in-line\") module definitions.","ref":"Croma.TypeGen.html","title":"Croma.TypeGen","type":"module"},{"doc":"Creates a new module that simply represents a type whose sole member is the given value.\n\nOnly atoms and integers are supported.","ref":"Croma.TypeGen.html#fixed/1","title":"Croma.TypeGen.fixed/1","type":"macro"},{"doc":"An ad-hoc version of `Croma.SubtypeOfList`.\n\nOptions:\n- `:define_default0?` - Boolean value that indicates whether to define `default/0` (which simply returns `[]`). Defaults to `true`.","ref":"Croma.TypeGen.html#list_of/2","title":"Croma.TypeGen.list_of/2","type":"macro"},{"doc":"Creates a new module that represents a nilable type, based on the given type module `module`.\n\nUsing the given type module `nilable/1` generates a new module that defines:\n\n- `@type t :: nil | module.t`\n- `@spec valid?(term) :: boolean`\n- `@spec default() :: nil`\n- If the given module exports `new/1`\n    - `@spec new(term) :: Croma.Result.t(t)`\n    - `@spec new!(term) :: t`\n\nThis is useful in defining a struct with nilable fields using `Croma.Struct`.","ref":"Croma.TypeGen.html#nilable/1","title":"Croma.TypeGen.nilable/1","type":"macro"},{"doc":"iex> use Croma\n    ...> defmodule I do\n    ...>   use Croma.SubtypeOfInt, min: 0\n    ...> end\n    ...> defmodule S do\n    ...>   use Croma.Struct, fields: [not_nilable_int: I, nilable_int: Croma.TypeGen.nilable(I)]\n    ...> end\n    ...> S.new(%{not_nilable_int: 0, nilable_int: nil})\n    %S{nilable_int: nil, not_nilable_int: 0}","ref":"Croma.TypeGen.html#nilable/1-examples","title":"Examples - Croma.TypeGen.nilable/1","type":"macro"},{"doc":"Creates a new module that represents a sum type of the given types.\n\nThe argument must be a list of type modules.\nNote that the specified types should be mutually disjoint;\notherwise `new/1` can return unexpected results depending on the order of the type modules.","ref":"Croma.TypeGen.html#union/1","title":"Croma.TypeGen.union/1","type":"macro"},{"doc":"Utilities to work with internal representation of types.","ref":"Croma.TypeUtil.html","title":"Croma.TypeUtil","type":"module"},{"doc":"","ref":"Croma.TypeUtil.html#fetch_spec_info_at_compile_time/1","title":"Croma.TypeUtil.fetch_spec_info_at_compile_time/1","type":"function"},{"doc":"","ref":"Croma.TypeUtil.html#fetch_type_info_at_compile_time/2","title":"Croma.TypeUtil.fetch_type_info_at_compile_time/2","type":"function"},{"doc":"","ref":"Croma.TypeUtil.html#list_to_type_union/1","title":"Croma.TypeUtil.list_to_type_union/1","type":"function"},{"doc":"","ref":"Croma.TypeUtil.html#resolve_primitive/3","title":"Croma.TypeUtil.resolve_primitive/3","type":"function"},{"doc":"Module for code generation of argument validation (see `Croma.Defun.defun/2`).\nThis module is intended for internal use.","ref":"Croma.Validation.html","title":"Croma.Validation","type":"module"},{"doc":"","ref":"Croma.Validation.html#make/3","title":"Croma.Validation.make/3","type":"function"},{"doc":"Custom compiler that checks if Croma consistently defines `new/1` functions.\n\nYou need to put `:croma` compiler after `:elixir` compiler.","ref":"Mix.Tasks.Compile.Croma.html","title":"mix compile.croma","type":"task"},{"doc":"","ref":"Croma.DebugAssertError.html","title":"Croma.DebugAssertError","type":"exception"}],"producer":{"name":"ex_doc","version":"0.37.0"},"proglang":"elixir"}